=== modified file 'src/com/goldencode/p2j/uast/ClassDefinition.java'
--- old/src/com/goldencode/p2j/uast/ClassDefinition.java	2021-03-23 11:42:56 +0000
+++ new/src/com/goldencode/p2j/uast/ClassDefinition.java	2021-04-15 14:18:30 +0000
@@ -3629,16 +3969,16 @@
     *
     * @return   List of possible methods that match.  This may be an empty list if no match exists.
     */
-   private List<MemberData> candidates(String            name,
-                                       int               num,
-                                       int               access,
-                                       boolean           isStatic,
-                                       boolean           internal,
-                                       boolean           first,
-                                       Set<SignatureKey> exist)
+   private List<MatchMetrics> candidates(String            name,
+                                          int               num,
+                                          int               access,
+                                          boolean           isStatic,
+                                          boolean           internal,
+                                          boolean           first,
+                                          Set<SignatureKey> exist)
    {
-      Set<SignatureKey> existing = exist == null ? new HashSet<>() : exist;
-      List<MemberData>  results  = new ArrayList<>();
+      Set<SignatureKey>   existing = exist == null ? new HashSet<>() : exist;
+      List<MatchMetrics> results  = new LinkedList<>();
       
       synchronized (lock)
       {
@@ -3652,25 +3992,32 @@
             {
                if (first)
                {
-                  results.add(defs.values().iterator().next());
+                  results.add(new MatchMetrics(defs.values().iterator().next()));
                   
                   return results;
                }
                
                Iterator<MemberData> iter = defs.values().iterator();
                
-               outer:
                while (iter.hasNext())
                {
                   MemberData dat = checkAccessRights(iter.next(), access);
                   
                   if (dat != null && dat.signature.length == num)
                   {
-                     SignatureKey key = (num > 0) ? new SignatureKey(dat.signature) : null;
-                     
-                     if (num == 0 || !existing.contains(key))
-                     {
-                        results.add(dat);
+                     // special case: no parameters; this is Highlander (i.e. "there can be only one")
+                     // and we don't have to search the parents, this is the match
+                     if (num == 0)
+                     {
+                        results.add(new MatchMetrics(dat));
+                        return results;
+                     }
+                     
+                     SignatureKey key = new SignatureKey(dat.signature);
+                     
+                     if (!existing.contains(key))
+                     {
+                        results.add(new MatchMetrics(dat));
                         existing.add(key);
                      }
                   }
@@ -3678,8 +4025,8 @@
             }
          }
          
-         // fuzzy matches are processed up the the parent hierarchy even if there are possible matches in
-         // the current class; static lookups only work for internal usage, non-static lookups always work
+         // matches are processed up the the parent hierarchy even if there are possible matches in the
+         // current class; static lookups only work for internal usage, non-static lookups always work
          if (parents != null && (!isStatic || internal))
          {
             // change access mode since we aren't allowed to see private stuff in parent
@@ -3687,7 +4034,7 @@
             
             for (ClassDefinition parent : parents)
             {
-               // recurse up inheritence hierarchy
+               // recurse up inheritance hierarchy
                results.addAll(parent.candidates(name, num, _access, isStatic, internal, first, existing));
             }
          }
@@ -3749,6 +4096,99 @@
       
       return type;
    }
+
+   /**
+    * Detect if the given class is an instance of an implemented interface of this class.
+    * 
+    * @param    cls
+    *           The class to check.
+    *           
+    * @return   {@code true} if the given class is an implemented interface in this class. 
+    */
+   private boolean isImplemented(ClassDefinition cls)
+   {
+      if (interfaces == null)
+         return false;
+      
+      return interfaces.contains(cls.getName()) || interfaces.contains(cls.getName().toLowerCase());
+   }
+   
+   /**
+    * Detect if the given class is an instance of a parent class or an implemented interface of a parent
+    * class.
+    * 
+    * @param    cls
+    *           The class to check.
+    * @param    ifaces
+    *           {@code true} if implemented interfaces should be checked.
+    * @param    incrementer
+    *           Code to be executed to increment the inheritance level.
+    *
+    * @return   {@code true} if the given class is a parent class or an implemented interface of a parent
+    *           class. 
+    */
+   private boolean isInheritedFrom(ClassDefinition cls, boolean ifaces, Runnable incrementer)
+   {
+      if (parents != null)
+      {
+         for (ClassDefinition parent : parents)
+         {
+            if (cls == parent || (ifaces && parent.isImplemented(cls)))
+            {
+               // track the current parent level
+               incrementer.run();
+
+               return true;
+            }
+            
+            if (parent.isInheritedFrom(cls, ifaces, incrementer))
+            {
+               // track our level's contribution to the parent level
+               incrementer.run();
+               
+               return true;
+            }
+         }
+      }
+      
+      return false;
+   }
+   
+   /**
+    * Parse the given object spec (in the form "object<? extends _CLS_>" or "jobject<? extends _CLS_>") and
+    * return the class definition associated with _CLS_.
+    * 
+    * @param    spec
+    *           The specification to parse.
+    *           
+    * @return   The class definition or {@code null} if the spec was malformed or if there is no such
+    *           definition.
+    */
+   private ClassDefinition parseObjectSpec(String spec)
+   {
+      String sig = "object<? extends ";
+      int    idx = spec.indexOf(sig);
+      
+      ClassDefinition cls = null;
+      
+      if (idx != -1)
+      {
+         String cname = spec.substring(idx + sig.length(), spec.length() - 1);
+         
+         cls = SymbolResolver.getClassDefinition(cname);
+         
+         if (cls == null)
+         {
+            System.err.printf("ERROR: No class found for %s (object spec %s)!\n", cname, spec);
+         }
+      }
+      else
+      {
+         System.err.printf("ERROR: Malformed object spec %s!\n", spec);
+      }
+      
+      return cls;
+   }
    
    /**
     * Check if the callee's type can be written back to a wider caller's type, when viewed from the
@@ -3766,30 +4206,47 @@
     * </pre>
     * <p>
     * Object types narrow by these rules:
-    *
+    * <ol>
+    *    <li> We check if the callee matches a child class of the caller type's specific class.  The
+    *         nearest child class is matched with highest priority.
+    * </ol>
     *
     * @param    caller
     *           The caller's passed instance's data type.
     * @param    callee
     *           The candidate callee method's parameter data type.
+    * @param    incrementer
+    *           Code to be executed to increment the inheritance level.
     *
     * @return   {@code true} if a narrowing operation is possible.
     */
-   private boolean isNarrowingTypeMatch(String caller, String callee)
+   private boolean isNarrowingTypeMatch(String caller, String callee, Runnable incrementer)
    {
-      if (("int64".startsWith(caller)      && "integer".startsWith(callee))               ||
-          ("longchar".startsWith(caller)   && "character".startsWith(callee))             ||
-          ("datetime".startsWith(caller)   && "date".startsWith(callee))                  ||
-          ("datetimetz".startsWith(caller) && ("date".startsWith(callee) || "datetime".startsWith(callee))))
+      if (("int64".equals(caller)      && "integer".equals(callee))                             ||
+          ("decimal".equals(caller)    && ("integer".equals(callee) || "int64".equals(callee))) ||
+          ("longchar".equals(caller)   && "character".equals(callee))                           ||
+          ("datetime".equals(caller)   && "date".equals(callee))                                ||
+          ("datetimetz".equals(caller) && ("date".equals(callee) || "datetime".equals(callee))))
       {
          return true;
       }
           
       if (caller.startsWith("object") && callee.startsWith("object"))
       {
-         return true;
+         // parse out the classes
+         ClassDefinition src = parseObjectSpec(caller);
+         ClassDefinition tgt = parseObjectSpec(callee);
+         
+         // check if the target parameter is a child class of the caller (this explicitly ignores
+         // implemented interfaces which is how the 4GL does it)
+         if (tgt.isInheritedFrom(src, false, incrementer))
+         {
+            return true;
+         }
+         
+         return false;
       }
-      
+                
       return false;
    }
    
@@ -3807,32 +4264,57 @@
     * datetime           datetime-tz
     * </pre>
     * <p>
-    * Object types narrow by these rules:
-    *
+    * Object types widen by these rules:
+    * <ol>
+    *    <li> We check if the callee matches any of the interfaces implemented by the caller type's specific class.
+    *    <li> We check if the callee matches any of the parent class hierarchy (and their implemented interfaces)
+    *         of the caller type's specific class.
+    *    <li> We check if the callee is Progress.Lang.Object.  This check has lowest priority.
+    * </ol>
     *
     * @param    caller
     *           The caller's passed instance's data type.
     * @param    callee
     *           The candidate callee method's parameter data type.
+    * @param    incrementer
+    *           Code to be executed to increment the inheritance level.
     *
     * @return   {@code true} if a widening operation is possible.
     */
-   private boolean isWideningTypeMatch(String caller, String callee)
+   private boolean isWideningTypeMatch(String caller, String callee, Runnable incrementer)
    {
-      if (("int64".startsWith(caller) && "decimal".startsWith(callee))                                   ||
-          ("integer".startsWith(caller) && ("int64".startsWith(callee) || "decimal".startsWith(callee))) ||
-          ("character".startsWith(caller) && "longchar".startsWith(callee))                              ||
-          ("datetime".startsWith(caller) && "datetimetz".startsWith(callee))                             ||
-          ("date".startsWith(caller) && ("datetime".startsWith(callee) || "datetimetz".startsWith(callee))))
+      if (("int64".equals(caller) && "decimal".equals(callee))                                   ||
+          ("integer".equals(caller) && ("int64".equals(callee) || "decimal".equals(callee)))     ||
+          ("character".equals(caller) && "longchar".equals(callee))                              ||
+          ("datetime".equals(caller) && "datetimetz".equals(callee))                             ||
+          ("date".equals(caller) && ("datetime".equals(callee) || "datetimetz".equals(callee))))
       {
          return true;
       }
+      
+      if (caller.startsWith("object") && callee.startsWith("object"))
+      {
+         // parse out the classes
+         ClassDefinition src = parseObjectSpec(caller);
+         ClassDefinition tgt = parseObjectSpec(callee);
+         
+         // check if the target is in the interface list of the caller type's specific class
+         if (src.isImplemented(tgt))
+         {
+            return true;
+         }
+         
+         // check if the target matches the caller type's parent class hierarchy (including implemented
+         // interfaces)
+         if (src.isInheritedFrom(tgt, true, incrementer))
+         {
+            return true;
+         }
+
+         // lowest priority/last ditch check
+         return "progress.lang.object".equals(tgt.getName());
+      }
                 
-      if (caller.startsWith("object") && callee.startsWith("object"))
-      {
-         return true;
-      }
-      
       return false;
    }
    
@@ -4155,244 +4637,55 @@
    }
    
    /**
-    * Stores a member's data.
+    * Returns the result from a method lookup.
     */
-   private static class MemberData
+   private static class MethodSearchResult
    {
-      /** Text name. */
-      private String name = null;
-      
-      /** Token type. */
-      private int type = -1;
-      
-      /** Extent value (defaults to 0, which means scalar) of the return type. */
-      private int extent = 0;
-      
-      /** Access mode. */
-      private int access = -1;
-      
-      /** Temporary ID. */
-      private int tempIdx = -1;
-      
-      /** Static or instance member. */
-      private boolean isStatic = false;
-      
-      /** Class type name for members that return an object instance. */
-      private String qname = null;
-      
-      /** Parameter signature for methods. */
-      private ParameterKey[] signature = null;
-      
-      /** Associated variable instance for data members. */
-      private Variable var = null; // used only during parsing/front phase
-      
-      /** The containing class where this was defined. */
-      private ClassDefinition container = null;
-      
-      /** The parameter modes. */
-      private String modes = null;
-      
-      /**
-       * Marker for OO vars which are gathered during pre-scan, and they might not be actual class
-       * members (as pre-scan processes DEFINE VAR statements at all levels, including methods).
-       */
-      private boolean provisional = false;
-      
-      /** The AST for this member definition. After parsing is finished, this is cleared. */
-      private Aast ast = null;
-      
-      /** The AST's ID for this member definition. */
-      private Long astId = null;
+      /** The method that was found. */
+      final private MemberData data;
+      
+      /** Type overrides for fuzzy matches. */
+      final private String[] overrides;
 
-      /** All annotations set at the method's return type. */
-      // WARNING: this is not set by initialize, in case of METHOD
-      private Map<String, Object> retType;
-      
-      /** 
-       * The converted Java name for this member. Used only for previously parsed classes, or
-       * legacy builtin classes.
-       */
-      private String javaname = null;
-      
-      /**
-       * Create an instance, setting the data members.
-       *
-       * @param    name
-       *           The name of the member.
-       * @param    var
-       *           Associated variable instance for data members or <code>null</code>.
-       * @param    signature
-       *           Parameter signature for methods or <code>null</code>.
-       * @param    type
-       *           The token type associated with the member.
-       * @param    access
-       *           Access mode (<code>KW_PUBLIC</code>,
-       *           <code>KW_PROTECTD</code> or <code>KW_PRIVATE</code>).
-       * @param    isStatic
-       *           <code>true</code> if the variable/property is static.
-       * @param    qname
-       *           Fully qualified class name where <code>type</code> equals
-       *           <code>OO_METH_CLASS</code>. <code>null</code> if this method
-       *           does not return an object instance.
-       * @param    container
-       *           The container class definition.
-       * @param    tempIdx
-       *           Temporary ID.
-       */
-      public MemberData(String          name,
-                        Variable        var,
-                        ParameterKey[]  signature,
-                        int             type,
-                        int             access,
-                        boolean         isStatic,
-                        String          qname,
-                        ClassDefinition container,
-                        int             tempIdx,
-                        Map<String, Object> retType)
-      {
-         this.name      = name;
-         this.var       = var;
-         this.signature = signature;
-         this.type      = type;
-         this.access    = access;
-         this.isStatic  = isStatic;
-         this.qname     = qname;
-         this.retType   = retType;
-         this.container = container;
-         this.tempIdx   = tempIdx;
-         
-         if (signature != null)
-         {
-            this.modes = "";
-            for (ParameterKey pk : signature)
-            {
-               if (pk.mode == null)
-               {
-                  modes = modes + "B";
-                  continue;
-               }
-               
-               switch (pk.mode)
-               {
-                  case KW_INPUT:
-                     modes = modes + "I";
-                     break;
-                  case KW_OUTPUT:
-                     modes = modes + "O";
-                     break;
-                  case KW_IN_OUT:
-                     modes = modes + "U";
-                     break;
-                  case KW_BUFFER:
-                     modes = modes + "B";
-                     break;
-               }
-            }
-         }
-      }
-      
-      /**
-       * The parse for this entire file has finished, and the AST IDs have been computed.  
-       * This is the time the capture the AST IDs or add other annotations, as is executed just
-       * before the AST is persisted.
-       */
-      public void parseFinished()
-      {
-         BiConsumer<Aast, Aast> p = (ast, parent) ->
-         {
-            if (ast.isAnnotation("access-mode"))
-            {
-               parent.putAnnotation("access-mode", (Long) ast.getAnnotation("access-mode"));
-               ast.removeAnnotation("access-mode");
-            }
-            if (ast.isAnnotation("oo-data-store"))
-            {
-               parent.putAnnotation("oo-data-store", (String) ast.getAnnotation("oo-data-store"));
-               ast.removeAnnotation("oo-data-store");
-            }
-            if (ast.isAnnotation("static"))
-            {
-               parent.putAnnotation("static", (Boolean) ast.getAnnotation("static"));
-               ast.removeAnnotation("static");
-            }
-         };
-         if (ast != null)
-         {
-            int type = ast.getType();
-            if (type == KW_TEMP_TAB ||
-                (type == SYMBOL && ast.getParent().getType() == DEFINE_BUFFER))
-            {
-               Aast parent = ast.getParent();
-               p.accept(ast, parent);
-               
-               if (type == KW_TEMP_TAB || type == KW_WORK_TAB)
-               {
-                  ast = parent;
-               }
-               else
-               {
-                  ast = parent;
-                  ast = ast.getImmediateChild(KW_FOR, null);
-                  ast = (Aast) ast.getFirstChild();
-               }
-            }
-            if (type == SYMBOL && ast.upPath("DEFINE_QUERY/KW_QUERY"))
-            {
-               Aast parent = ast.getAncestor(2);
-               p.accept(ast, parent);
-               
-               parent.putAnnotation("name", ast.getText());
-               ast = parent;
-            }
-            
-            astId = ast.getId();
-            ast = null;
-         }
-      }
-      
-      /**
-       * Set the {@link #provisional} state of this member.
-       * 
-       * @param    provisional
-       *           The new state.
-       */
-      public void setProvisional(boolean provisional)
-      {
-         this.provisional = provisional;
-      }
-      
-      /**
-       * Render the state of the instance in a text form.
-       *
-       * @return   The rendered instance.
-       */
-      public String toString()
-      {
-         StringBuilder sb = new StringBuilder();
-         
-         String qual = (qname == null) ? "" : String.format(" - %s", qname);
-         
-         sb.append(String.format("%s %b member %s (%s%s), extent %d in class %s, tempIdx %d\n",
-                                 ProgressParser.lookupTokenName(access),
-                                 isStatic,
-                                 name,
-                                 ProgressParser.lookupTokenName(type),
-                                 qual,
-                                 extent,
-                                 container.getName(),
-                                 tempIdx));
-          
-         if (signature != null)
-         {
-            sb.append(String.format("   PARAMETERS: %d\n", signature.length));
-            
-            for (int i = 0; i < signature.length; i++)
-            {
-               sb.append(String.format("      %s\n", signature[i]));
-            }
-         }
-         
-         return sb.toString();
+      /**
+       * Create an dynamic invocation instance.
+       */
+      MethodSearchResult()
+      {
+         data      = null;
+         overrides = null;
+      }
+      
+      /**
+       * Create an instance using the given result.
+       * 
+       * @param    data
+       *           The result of the search.
+       */
+      MethodSearchResult(MemberData data, String[] overrides)
+      {
+         this.data      = data;
+         this.overrides = overrides;
+      }
+      
+      /**
+       * Reports if this is a dynamic invocation.
+       * 
+       * @return   {@code true} if this is a dynamic invocation.
+       */
+      boolean isDynamic()
+      {
+         return data == null;
+      }
+      
+      /**
+       * Obtain any types overrides which are needed because of fuzzy matching.
+       *  
+       * @return   The type overrides defined for this match or {@code null} if there are no overrides.
+       */
+      String[] getOverrides()
+      {
+         return overrides;
       }
    }
 }

=== modified file 'src/com/goldencode/p2j/uast/ParameterKey.java'
--- old/src/com/goldencode/p2j/uast/ParameterKey.java	2019-05-20 17:03:26 +0000
+++ new/src/com/goldencode/p2j/uast/ParameterKey.java	2021-03-30 18:08:22 +0000
@@ -2,14 +2,14 @@
 ** Module   : ParameterKey.java
 ** Abstract : wrapper for a parameter signature in a method.
 **
-** Copyright (c) 2018-2019, Golden Code Development Corporation.
+** Copyright (c) 2018-2021, Golden Code Development Corporation.
 **
-** -#- -I- --Date-- ---------------------------------Description----------------------------------
+** -#- -I- --Date-- --------------------------------------Description---------------------------------------
 ** 001 CA  20181229 First version.
-** 002 CA  20190423 WrappedResource must be treated as a handle type.  Normalized DataSet type's
-**                  case.
-** 003 CA  20190508 Changes to solve collisions in converted Java signature collisions for 
-**                  overloaded methods.
+** 002 CA  20190423 WrappedResource must be treated as a handle type.  Normalized DataSet type's case.
+** 003 CA  20190508 Changes to solve collisions in converted Java signature collisions for overloaded 
+**                  methods.
+** 004 GES 20210305 Added typeEquivalent().
 */
 
 /*
@@ -76,8 +76,6 @@
 /**
  * Container for a parameter's key, including its data type and mode.  Used both at caller and
  * at the OO method definition.
- * 
- * TODO: table parameters are matched via the temp-table's field types
  */
 public class ParameterKey
 {
@@ -111,6 +109,31 @@
    }
    
    /**
+    * Report if the type of the two parameters is the same. The mode is not considered.
+    * 
+    * @param    other
+    *           The instance to compare against.
+    *           
+    * @return   {@code true} if the types are the same or are both {@code null}.  If they are different
+    *           (including if only one is {@code null}) then {@code false} will be returned. 
+    */
+   public boolean typeEquivalent(ParameterKey other)
+   {
+      return Objects.equals(this.type, other.type);
+   }
+   
+   /**
+    * Report the type without any encoded extent.
+    * 
+    * @return   The type with any extent portion removed. 
+    */
+   public String scalarType()
+   {
+      int idx = type.indexOf('[');
+      return (idx < 0) ? type : type.substring(0, idx);
+   }
+   
+   /**
     * Test {@code other} object for equality.
     * 
     * @param   other
@@ -125,14 +148,15 @@
       {
          return true;
       }
-      if (other == null || getClass() != other.getClass())
+      
+      if (other == null || !(other instanceof ParameterKey))
       {
          return false;
       }
       
       ParameterKey otherKey = (ParameterKey) other;
       
-      return Objects.equals(this.mode, otherKey.mode) && Objects.equals(this.type, otherKey.type);
+      return Objects.equals(this.mode, otherKey.mode) && typeEquivalent(otherKey);
    }
    
    /**
@@ -178,8 +202,6 @@
     */
    public String toJava()
    {
-      // TODO: some of these calls must be marked as 'dynamic'??
-
       if (type.indexOf('[') > 0)
       {
          switch (mode.intValue())
@@ -200,12 +222,14 @@
          return object.class.getSimpleName();
       }
       
-      if (type.equalsIgnoreCase("dataset") || type.equalsIgnoreCase("dataset-handle"))
+      // this matches both "dataset <signature>" and "dataset-handle"
+      if (type.toLowerCase().startsWith("dataset"))
       {
          return DataSetParameter.class.getSimpleName();
       }
 
-      if (type.equalsIgnoreCase("temp-table") || type.equalsIgnoreCase("table-handle"))
+      // for "temp-table <signature>" we can't just check equals because it has the field structure encoded 
+      if (type.toLowerCase().startsWith("temp-table") || type.equalsIgnoreCase("table-handle"))
       {
          return TableParameter.class.getSimpleName();
       }

